--------------------------------------------------------------------------------
-- i2c_wrapper.vhd
--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

-- synthesis translate_off
LIBRARY UNISIM;
USE UNISIM.VCOMPONENTS.ALL;
-- synthesis translate_on

LIBRARY opb_i2ccontroller_v1_00_a;
USE opb_i2ccontroller_v1_00_a.ALL;

ENTITY i2c_wrapper IS
PORT (
	-- instance i2c
	VID_I2C_SCL : INOUT STD_LOGIC;
	VID_I2C_SDA : INOUT STD_LOGIC;
	OPB_Clk : IN STD_LOGIC;
	OPB_ABus : IN STD_LOGIC_VECTOR(0 TO 31);
	OPB_BE : IN STD_LOGIC_VECTOR(0 TO 3);
	OPB_DBus : IN STD_LOGIC_VECTOR(0 TO 31);
	OPB_RNW : IN STD_LOGIC;
	OPB_Rst : IN STD_LOGIC;
	OPB_select : IN STD_LOGIC;
	OPB_seqaddr : IN STD_LOGIC;
	VID_I2C_DBus : OUT STD_LOGIC_VECTOR(0 TO 31);
	VID_I2C_errAck : OUT STD_LOGIC;
	VID_I2C_retry : OUT STD_LOGIC;
	VID_I2C_toutSup : OUT STD_LOGIC;
	VID_I2C_xferAck : OUT STD_LOGIC);
END i2c_wrapper;

ARCHITECTURE IMP OF i2c_wrapper IS

--------------------------------------------------------------------------------
COMPONENT opb_i2ccontroller IS
GENERIC (
	c_baseaddr : STD_LOGIC_VECTOR := X"feff0200";
	c_highaddr : STD_LOGIC_VECTOR := X"feff02ff";
	c_opb_awidth : INTEGER := 32;
	c_opb_dwidth : INTEGER := 32);
PORT (
	VID_I2C_SCL : INOUT STD_LOGIC;
	VID_I2C_SDA : INOUT STD_LOGIC;
	OPB_Clk : IN STD_LOGIC;
	OPB_ABus : IN STD_LOGIC_VECTOR(0 TO (C_OPB_AWIDTH-1));
	OPB_BE : IN STD_LOGIC_VECTOR(0 TO ((C_OPB_DWIDTH/8)-1));
	OPB_DBus : IN STD_LOGIC_VECTOR(0 TO (C_OPB_DWIDTH-1));
	OPB_RNW : IN STD_LOGIC;
	OPB_Rst : IN STD_LOGIC;
	OPB_select : IN STD_LOGIC;
	OPB_seqaddr : IN STD_LOGIC;
	VID_I2C_DBus : OUT STD_LOGIC_VECTOR(0 TO (C_OPB_DWIDTH-1));
	VID_I2C_errAck : OUT STD_LOGIC;
	VID_I2C_retry : OUT STD_LOGIC;
	VID_I2C_toutSup : OUT STD_LOGIC;
	VID_I2C_xferAck : OUT STD_LOGIC);
END COMPONENT;

--------------------------------------------------------------------------------
-- internal signals
--------------------------------------------------------------------------------

BEGIN

--------------------------------------------------------------------------------
-- Power assignments
--------------------------------------------------------------------------------
-- Constant assignments
--------------------------------------------------------------------------------
-- Top-level port assignments
--------------------------------------------------------------------------------
-- Lower-level assignments

--------------------------------------------------------------------------------
opb_i2ccontroller_0_i : opb_i2ccontroller
GENERIC MAP (
	c_baseaddr => X"feff0200",
	c_highaddr => X"feff02ff",
	c_opb_awidth => 32,
	c_opb_dwidth => 32)
PORT MAP (
	VID_I2C_SCL => VID_I2C_SCL,
	VID_I2C_SDA => VID_I2C_SDA,
	OPB_Clk => OPB_Clk,
	OPB_ABus => OPB_ABus,
	OPB_BE => OPB_BE,
	OPB_DBus => OPB_DBus,
	OPB_RNW => OPB_RNW,
	OPB_Rst => OPB_Rst,
	OPB_select => OPB_select,
	OPB_seqaddr => OPB_seqaddr,
	VID_I2C_DBus => VID_I2C_DBus,
	VID_I2C_errAck => VID_I2C_errAck,
	VID_I2C_retry => VID_I2C_retry,
	VID_I2C_toutSup => VID_I2C_toutSup,
	VID_I2C_xferAck => VID_I2C_xferAck);

END ARCHITECTURE IMP;
